<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table user -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title>
                  <h1>User</h1>
                </v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_user = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-account-plus</v-icon>
                      Add User
                    </v-btn>
                    <v-btn
                      @click="delete_user"
                      type="button"
                      color="error"
                      small
                      :disabled="disble_delete"
                      ><v-icon small class="pr-1">mdi-delete</v-icon>
                      Delete User
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    v-model="selected"
                    :headers="headers"
                    :items="all_user"
                    :search="search"
                    :single-select="singleSelect"
                    show-select
                    item-key="username"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_user(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>

                      &nbsp;&nbsp;
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="forget_password(item)"
                            color="warning"
                          >
                            mdi-lock-reset
                          </v-icon>
                        </template>
                        <span>Forget password</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table user -->

    <!-- dialog_add_user -->
    <v-dialog v-model="dialog_add_user" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Add User</v-card-title>
        <v-form ref="form_add_user">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-autocomplete
                    :items="list_user_oneid"
                    outlined
                    dense
                    return-object=""
                    v-model="form_add_user.validate_useroneid"
                    :rules="userOneidRules"
                    label="user oneid"
                  >
                    <template slot="selection" slot-scope="{ item }">
                      {{ item.first_name }} {{ item.last_name }}
                    </template>
                    <template slot="item" slot-scope="{ item }">
                      {{ item.first_name }} {{ item.last_name }}
                    </template>
                  </v-autocomplete>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-autocomplete
                    :items="list_hospital_name"
                    item-text="hospital_name_th"
                    outlined
                    dense
                    return-object=""
                    v-model="form_add_user.hospital_name_th"
                    :rules="hospital_nameRules"
                    label="hospital name"
                  ></v-autocomplete>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_user.username"
                    :rules="usernameRules"
                    label="username"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_user.email"
                    :rules="emailRules"
                    label="email"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-select
                    outlined
                    dense
                    :items="list_role"
                    v-model="form_add_user.role"
                    :rules="roleRules"
                    label="role"
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-autocomplete
                    :items="list_user_admin"
                    item-text="nickname"
                    outlined
                    dense
                    return-object=""
                    v-model="form_add_user.oneid"
                    :rules="nicknameRules"
                    label="admin name"
                  ></v-autocomplete>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_user -->

    <!-- dialog_edit_user -->
    <v-dialog v-model="dialog_edit_user" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Edit User</v-card-title>
        <v-form ref="form_edit_user">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-autocomplete
                    :items="list_hospital_name"
                    item-text="hospital_name_th"
                    outlined
                    dense
                    return-object=""
                    v-model="form_edit_user.hospital_name_th"
                    :rules="hospital_nameRules"
                    label="hospital name"
                  ></v-autocomplete>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_user.username"
                    :rules="usernameRules"
                    label="username"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_user.email"
                    :rules="emailRules"
                    label="email"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-select
                    outlined
                    dense
                    :items="list_role"
                    v-model="form_edit_user.role"
                    :rules="roleRules"
                    label="role"
                  ></v-select>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_edit" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_edit_user End -->

    <!-- dialog_reset_password -->
    <v-dialog v-model="dialog_reset_password" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Reset Password</v-card-title>
        <v-form ref="form_forget_password">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-autocomplete
                    :items="list_user_admin"
                    item-text="nickname"
                    outlined
                    dense
                    return-object=""
                    v-model="form_forget_password.oneid"
                    :rules="nicknameRules"
                    label="admin nickname"
                  ></v-autocomplete>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_reset" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_reset" style="color: white">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_reset_password End -->
  </v-app>
</template>

<script>
export default {
  name: "User",
  data() {
    return {
      api: process.env.VUE_APP_API,
      fab: false,
      dialog_add_user: false,
      dialog_edit_user: false,
      dialog_forget_user: false,
      dialog_reset_password: false,
      singleSelect: false,
      selected: [],
      disble_delete: true,
      dialog_loader: false,
      search: "",
      list_hospital_name: [],
      list_user_admin: [],
      list_user_oneid: [],
      list_role: ["superadmin", "admin", "user", "viewer"],
      all_user: [],
      headers: [
        {
          text: "Username",
          align: "start",
          value: "username",
          sortable: false,
        },
        {
          text: "Hospital Name",
          align: "start",
          value: "hospital_name_th",
          sortable: false,
        },
        {
          text: "Email",
          align: "start",
          value: "email",
          sortable: false,
        },
        {
          text: "Role",
          align: "start",
          value: "role",
          sortable: false,
        },
        { text: "Action", value: "actions", sortable: false },
      ],
      form_add_user: {
        validate_useroneid: "",
        username: "",
        hospital_name_th: "",
        email: "",
        role: "",
        hospital_id: "",
        oneid: "",
        user_oneid: "",
      },
      form_edit_user: {
        username: "",
        hospital_name_th: "",
        email: "",
        role: "",
        hospital_id: "",
      },
      usernameRules: [(v) => !!v || "Please enter username"],
      hospital_nameRules: [(v) => !!v || "Please enter hospital name"],
      nicknameRules: [(v) => !!v || "Please enter admin nickname"],
      userOneidRules: [(v) => !!v || "Please enter user oneid"],
      emailRules: [
        (v) => !!v || "Please enter email",
        (v) =>
          /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) ||
          "Form email incorect",
      ],
      roleRules: [(v) => !!v || "Please enter role"],
      form_forget_password: {
        user_id: "",
        email: "",
        oneid: "",
      },
      old_passwordRules: [(v) => !!v || "Please enter old password"],
      new_passwordRules: [(v) => !!v || "Please enter new password"],
      session_id: this.$cookies.get("info_login").session_id,
    };
  },
  mounted() {
    // console.log("process.env.VUE_APP_API", process.env.VUE_APP_API);
    console.log("api -->", this.api);
    this.get_hospital();
    this.get_user();
    this.get_user_admin();
    this.get_user_oneid();
  },
  watch: {
    selected(val) {
      console.log(val);
      if (val.length == 0) {
        this.disble_delete = true;
      } else {
        this.disble_delete = false;
      }
    },
    "form_add_user.validate_useroneid": function(val) {
      if (val.email == null) {
        // console.log("null");
        this.form_add_user.user_oneid = "";
        this.form_add_user.email = "";
        this.form_add_user.hospital_name_th = "";
        this.form_add_user.hospital_id = "";
      } else {
        // console.log("watch_oneid", val);
        this.form_add_user.user_oneid = val.oneid_account;
        this.form_add_user.email = val.email;
        this.form_add_user.hospital_name_th = val.hospital_name_th;
        this.form_add_user.hospital_id = val.hospital_id;
      }
    },
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_user_oneid() {
      let userlogId = this.$cookies.get("info_login").user_id;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/oneid_admin/getuser_oneid", {
          params: {
            token: this.$cookies.get("info_login").token,
            userlog_id: userlogId,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("list_user_oneid", response.data.data);
          this.list_user_oneid = response.data.data;
          this.list_user_oneid.unshift({
            first_name: "--------- ไม่มีข้อมูล OneID ---------",
          });
        })
        .catch((error) => {
          console.log(error);
        });
    },

    get_user_admin() {
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/oneid_admin", {
          params: {
            token: this.$cookies.get("info_login").token,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("data_all_admin", response.data.data);
          this.list_user_admin = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
        });
    },

    get_hospital() {
      const user_id = this.$cookies.get("info_login").user_id;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/hospital_contract", {
          params: {
            userlog_id: user_id,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          for (let index = 0; index < response.data.data.length; index++) {
            this.list_hospital_name.push(response.data.data[index]);
          }
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    get_user() {
      let userlogId = this.$cookies.get("info_login").user_id;
      this.dialog_loader = true;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/user", {
          params: {
            userlog_id: userlogId,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          this.dialog_loader = false;
          console.log("response", response.data.data);
          if (response.data.status == "fail") {
            this.$swal({
              icon: "error",
              title: "Error!",
              text: response.data.message,
              confirmButtonText: "OK",
              allowOutsideClick: false,
            }).then(() => {
              window.location.href = this.api;
            });
          } else {
            this.all_user = response.data.data;
          }
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    cancel_add() {
      this.$refs.form_add_user.reset();
      this.form_add_user.validate_useroneid = "";
      this.dialog_add_user = false;
    },

    save_add() {
      if (!this.$refs.form_add_user.validate()) return;
      this.dialog_add_user = false;
      console.log("validate", this.form_add_user.validate_useroneid);
      if (this.form_add_user.validate_useroneid.first_name == "--------- ไม่มีข้อมูล OneID ---------") {
        this.form_add_user["hospital_id"] = this.form_add_user.hospital_name_th.hospital_id;
        this.form_add_user["hospital_name_th"] = this.form_add_user.hospital_name_th.hospital_name_th;
      }
      this.form_add_user["userlog_id"] = this.$cookies.get("info_login").user_id;
      this.form_add_user["oneid"] = this.form_add_user.oneid.oneid;
      console.log("*****form_add_user", this.form_add_user);
      this.axios
        .post(process.env.VUE_APP_API + "/api/v3/user", this.form_add_user, {
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response", response.data.message);
          if (response.data.message == "username duplicate") {
            this.$swal({
              icon: "error",
              title: "Error!",
              text: response.data.message + ".",
              confirmButtonText: "OK",
              allowOutsideClick: false,
            }).then(() => {
              this.get_user();
              this.$refs.form_add_user.reset();
              this.form_add_user.validate_useroneid = "";
            });
          } else {
            this.$swal({
              icon: "success",
              title: "Success!",
              text: response.data.message + ".",
              confirmButtonText: "OK",
              allowOutsideClick: false,
            }).then(() => {
              this.get_user();
              this.$refs.form_add_user.reset();
              this.form_add_user.validate_useroneid = "";
            });
          }
        })
        .catch((error) => {
          console.log("error", error);
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    edit_user(item) {
      this.form_edit_user = item;
      this.dialog_edit_user = true;
    },

    cancle_edit() {
      this.dialog_edit_user = false;
      this.get_user();
    },

    save_edit() {
      this.dialog_loader = true;
      if (!this.$refs.form_edit_user.validate()) return;
      this.dialog_edit_user = false;
      // console.log(this.form_edit_user);
      // console.log("hospital_name_th", this.form_edit_user.hospital_name_th.hospital_name_th);
      // console.log("hospital_id", this.form_edit_user.hospital_name_th.hospital_id);
      this.form_edit_user["hospital_id"] = this.form_edit_user.hospital_name_th.hospital_id;
      this.form_edit_user["hospital_name_th"] = this.form_edit_user.hospital_name_th.hospital_name_th;
      // console.log("form_edit_user", this.form_edit_user);
      this.form_edit_user["userlog_id"] = this.$cookies.get("info_login").user_id;
      this.axios
        .put(process.env.VUE_APP_API + "/api/v3/user", this.form_edit_user, {
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response", response.data.data);
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Edit user success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.dialog_loader = false;
            this.get_user();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    delete_user() {
      const user_id_array = [];
      console.log("selected", this.selected);
      for (let index = 0; index < this.selected.length; index++) {
        console.log(this.selected[index].user_id);
        user_id_array.push(this.selected[index].user_id);
      }
      console.log("array_user_id", user_id_array);
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete user!",
        icon: "warning",
        showCancelButton: true,
        allowOutsideClick: false,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(
              process.env.VUE_APP_API +
                "/api/v3/user?user_id=" +
                user_id_array +
                "&userlog_id=" +
                this.$cookies.get("info_login").user_id,
              {
                headers: {
                  Authorization: this.session_id,
                },
              }
            )
            .then((response) => {
              console.log(response.data);
              console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: "package is using.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user();
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete User success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user();
                });
              }
            })
            .catch((error) => {
              this.dialog_loader = false;
              console.log("error", error);
              this.$swal({
                icon: "error",
                title: "Error!",
                text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                window.location.href = this.api;
              });
            });
        }
      });
    },

    forget_password(item) {
      console.log(item);
      this.form_forget_password.user_id = item.user_id;
      this.form_forget_password.email = item.email;
      this.form_forget_password["userlog_id"] = this.$cookies.get("info_login").user_id;
      this.$swal({
        title: "Are you sure?",
        text: "You want to forget password!",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes",
      }).then((result) => {
        if (result.value) {
          this.dialog_reset_password = true;
        }
      });
    },

    cancle_reset() {
      this.dialog_reset_password = false;
    },
    save_reset() {
      if (!this.$refs.form_forget_password.validate()) return;
      this.form_forget_password.oneid = this.form_forget_password.oneid.oneid;
      // console.log("form-forget-password", this.form_forget_password);
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/user/forgetpassword",
          this.form_forget_password,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          console.log("response", response);
          this.$swal({
            icon: "success",
            title: "Success!",
            text: response.data.message + ".",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_user();
            this.dialog_reset_password = false;
          });
        })
        .catch((error) => {
          console.log("error", error);
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },
  },
};
</script>

<style></style>
